<?php


ini_set("display_errors", 1);
include __DIR__ . "/../includes/functions.php";

$jsonIn = file_get_contents("php://input");
$resonse = json_decode($jsonIn, true);
$decoded = base64_decode($resonse["data"]);
$authData = json_decode($decoded, true);
$portal = [];


$jsonFilePath = __DIR__ . '/device_keys.json';


$logFilePath = __DIR__ . '/connection_log.json';

// Função para ler o arquivo JSON e retornar os dados
function readDeviceKeys($filePath) {
    if (file_exists($filePath)) {
        $jsonData = file_get_contents($filePath);
        return json_decode($jsonData, true);
    }
    return [];
}


function saveDeviceKeys($filePath, $data) {
    file_put_contents($filePath, json_encode($data, JSON_PRETTY_PRINT));
}


function logConnection($filePath, $macAddress, $url) {
    $logData = [];
    

    if (file_exists($filePath)) {
        $jsonLog = file_get_contents($filePath);
        $logData = json_decode($jsonLog, true);
    }

 
    $newLogEntry = [
        "mac_address" => $macAddress,
        "date" => date("Y-m-d H:i:s"), 
        "url_accessed" => $url
    ];


    $logData[] = $newLogEntry;


    file_put_contents($filePath, json_encode($logData, JSON_PRETTY_PRINT));
}


$deviceKeys = readDeviceKeys($jsonFilePath);


if ($authData["app_device_id"]) {
    $macAddress = base64_decode($authData["app_device_id"]);
    $macAddress = substr($macAddress, 0, 12);
    $formattedMac = strtoupper(preg_replace("/..(?!\$)/", "\$0:", $macAddress));
} else {
    $formattedMac = strtoupper($authData["mac_address"]);
}


if (isset($deviceKeys[$formattedMac])) {

    $device_key = $deviceKeys[$formattedMac];
} else {

    $device_key = substr(md5($formattedMac), 0, 8);
    

    $deviceKeys[$formattedMac] = $device_key;
    saveDeviceKeys($jsonFilePath, $deviceKeys);
}


$res = $db->select("dns", "*", "", "");
foreach ($res as $row) {
    $result = $db->select("playlist", "*", "dns_id = :dns_id AND mac_address = :mac_address", "", [":dns_id" => $row["id"], ":mac_address" => $formattedMac]);
    if (!empty($result)) {
        $urlAccessed = $row["url"] . "/get.php?username=" . $result[0]["username"] . "&password=" . $result[0]["password"] . "&type=m3u_plus&output=ts";
        $portal[] = [
            "is_protected" => 0,
            "id" => $row["id"],
            "url" => $urlAccessed,
            "name" => $row["title"],
            "playlist_name" => $row["title"],
            "type" => "xc",
            "created_at" => "2023-03-26 16:42:48",
            "updated_at" => "2023-03-26 16:42:48"
        ];

       
        logConnection($logFilePath, $formattedMac, $urlAccessed);
    }
}


$backdropUrl = getbaseurl() . "/backdrop.php";
$settings = $db->select("settings", "*", "id = :id", "", [":id" => 1]);
$theme = $db->select("themes", "*", "id = :id", "", [":id" => 1]);
$theme_id = !empty($theme) ? $theme[0]["theme_id"] : "1";
$result_pin = $db->select("playlist", "*", "mac_address = :mac_address", "", [":mac_address" => $formattedMac]);


$response = [
    "android_version_code" => "1.0.0",
    "apk_url" => "",
    "device_key" => $device_key, 
    "expire_date" => "2034-03-26",
    "is_google_paid" => true,
    "is_trial" => 0,
    "languages" => json_decode(file_get_contents("language.json"), true),
    "mac_registered" => true,
    "themes" => [],
    "trial_days" => 7,
    "plan_id" => "36269518",
    "mac_address" => $formattedMac,
    "pin" => $result_pin[0]["pin"] ?? "0000",
    "price" => "7.99",
    "apk_link" => "",
    "urls" => $portal,
    "note_title" => $settings[0]["note_title"],
    "note_content" => $settings[0]["note_content"],
    "qr_url" => "",
    "qr_url_short" => "",
    "home_mode" => null,
    "home_url1" => $backdropUrl,
    "home_url2" => $backdropUrl,
    "theme" => $theme_id
];

echo Encryption::run(json_encode($response), "IBO_38");


function getBaseUrl() {
    $protocol = !empty($_SERVER["HTTPS"]) && $_SERVER["HTTPS"] !== "off" || $_SERVER["SERVER_PORT"] == 443 ? "https://" : "http://";
    $domainName = $_SERVER["HTTP_HOST"];
    $folderPath = dirname($_SERVER["PHP_SELF"]);
    return $protocol . $domainName . $folderPath;
}

?>
